#pragma once

#include <dune/amdis/linear_algebra/LinearSolverInterface.hpp>
#include <dune/amdis/linear_algebra/SolverInfo.hpp>

#if defined(AMDIS_BACKEND_ISTL)

#include <dune/amdis/linear_algebra/istl/SystemVector.hpp>
#include <dune/amdis/linear_algebra/istl/SystemMatrix.hpp>
#include <dune/amdis/linear_algebra/istl/LinearSolver.hpp>

#elif defined(AMDIS_BACKEND_MTL)

#include <dune/amdis/linear_algebra/mtl/SystemVector.hpp>
#include <dune/amdis/linear_algebra/mtl/SystemMatrix.hpp>
#include <dune/amdis/linear_algebra/mtl/LinearSolver.hpp>
#include <dune/amdis/linear_algebra/mtl/ITL_Solver.hpp>
#include <dune/amdis/linear_algebra/mtl/BITL_Solver.hpp>

#elif defined(AMDIS_BACKEND_PETSC)

#include <dune/amdis/linear_algebra/petsc/SystemVector.hpp>
#include <dune/amdis/linear_algebra/petsc/SystemMatrix.hpp>
#include <dune/amdis/linear_algebra/petsc/LinearSolver.hpp>

#else

#error "Unknown linear algebra backend!. Set corresponding variable \
        AMDIS_BACKEND_ISTL, AMDIS_BACKEND_MTL or AMDIS_BACKEND_PETSC."

#endif